#ifndef __os2asm_h
#define __os2asm_h

#ifndef __ttypes_h
#   include <tvision/ttypes.h>
#endif

/*
 *  This module provides the prototypes for the assembler functions. Originally
 *  these were implemented as "member functions" of the classes, but to make
 *  things more portable they are now implemented as C functions, so that
 *  name mangling is no longer problematic.
 *
 */
#if defined(__FLAT__) && defined(__OS2__)
class TDrawBuffer;

extern "C"
{
    //** TFrame member shit
    void _cdecl asmFrameLine(void* cls, TDrawBuffer& frameBuf, short y, short n, unsigned char color );

    //** TEditor member shit,
    char            _cdecl asmBufChar(void* cls, unsigned short );
    unsigned short  _cdecl asmBufPtr(void* cls, unsigned short );
    void            _cdecl asmFormatLine(void* cls, void *, unsigned short, int, unsigned short );
    unsigned short  _cdecl asmNextChar(void* cls, unsigned short );
    unsigned short  _cdecl asmPrevChar(void* cls, unsigned short );
    unsigned short  _cdecl asmLineEnd(void* cls, unsigned short );
    unsigned short  _cdecl asmLineStart(void* cls, unsigned short );

    int             _cdecl countLines( void *buf, unsigned int count );
    unsigned short  _cdecl scan( const void *block, unsigned short size, const char *str );
    unsigned short  _cdecl iScan( const void *block, unsigned short size, const char *str );

    //** TTerminal stuff,
    unsigned short  _cdecl asmPrevLines(void* cls, unsigned short, unsigned short);
    Boolean         _cdecl asmExposed(void* ths);

};

//** WatCOM compiler specifics..
#if 0
#pragma aux asmFrameLine    "_*";
#pragma aux asmBufChar      "_*";
#pragma aux asmBufPtr       "_*";
#pragma aux asmFormatLine   "_*";
#pragma aux asmNextChar     "_*";
#pragma aux asmPrevChar     "_*";
#pragma aux asmLineEnd      "_*";
#pragma aux asmLineStart    "_*";
#pragma aux countLines      "_*";
#pragma aux scan            "_*";
#pragma aux iScan           "_*";
#pragma aux asmPrevLines    "_*";
#pragma aux asmExposed      "_*";
#endif

#endif
#endif

